#pragma once
#include <cstdint>
#include <vector>

#include "lloiff.hpp"

namespace llo::s1
{
    /// <summary>
    /// base clase for all file format deconstructors...
    /// </summary>
    class dctor_base_t
    {
        /// <summary>
        /// vector of bytes containing the raw image to be deconstructed...
        /// </summary>
        std::vector< std::uint8_t > raw_img;

      public:
        /// <summary>
        /// set raw_img to the vector passed by reference...
        /// </summary>
        /// <param name="image">vector of bytes containing the raw image...</param>
        dctor_base_t( std::vector< std::uint8_t > &image ) : raw_img{ image }
        {
        }

        /// <summary>
        /// purely virtual method which gets overriden by classes that inherit
        /// dctor_base_t... fills the lloiff_t object full of data...
        /// </summary>
        /// <param name="iff"></param>
        /// <returns></returns>
        virtual bool generate( lloiff_t &iff ) = 0;
    };
} // namespace llo::s1